'use strict';

const config = require('./../../config');
const logger = require('./../../utils/logger');
const errors = require('./../../utils/dz-errors-api');
const dbConstants = require('./../../constants/db-constants');
const query = require('./../../utils/query-creator-api');
let async = require('async');
let _ = require('underscore');

/*
	Name : List
	Purpose : List
	Original Author : Gaurav Patel
    Created At : 8th Mar 2021
*/
const list = async(requestParam) => {
    return new Promise(async(resolve, reject) => {
        try {
            let data = await query.selectWithAnd(dbConstants.dbSchema.vehicle_types, { status: 'active'}, { _id: 0, vehicle_type_id: 1, title: 1, description:1, icon:1, is_open_custom_box:1, code:1 }, { order_no: 1 });
            data = JSON.parse(JSON.stringify(data));
            _.each(data, (element, index, list) => {
                element['title'] = element.title[requestParam.code] || '';
                element['description'] = element.description[requestParam.code] || '';
                element['icon'] = element['icon'] !='' ? config.aws.prefix + config.aws.s3.vehicleTypeBucket + '/' + element.icon : '';
            });

            resolve(data)
            return;
        } catch (error) {
            reject(error)
            return
        }
    })
};

module.exports = {
    list
};