// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var accessInstructionSchema = new Schema({
    access_instruction_id: {
        type: String,
        default:''
    },
    title: {
        type: Object,
        default:{}
    },
    order_no: {
        type: Number,
        default:0
    },
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    is_open_custom_box: {
        type: Boolean,
        default:false
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
accessInstructionSchema.pre('save', function(callback) {
    idGenerator.generateId('access_instructions', 'access_instruction_id', 'ACI', (err, ID) => {
        this.access_instruction_id = ID;
        callback();
    });
});

var Access_instruction = mongoose.model('Access_instruction', accessInstructionSchema);
module.exports = Access_instruction;