// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var bankSchema = new Schema({
    bank_id: {
        type: String,
        default:''
    },
    title: {
        type: Object,
        default:{}
    },
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
bankSchema.pre('save', function(callback) {
    idGenerator.generateId('banks', 'bank_id', 'BNK', (err, ID) => {
        this.bank_id = ID;
        callback();
    });
});

var Bank = mongoose.model('Bank', bankSchema);
module.exports = Bank;