const mongoose = require('mongoose');
const Schema = mongoose.Schema;
const shortid = require('shortid');
shortid.characters('0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$@');

// State Schema
const chatSchema = new Schema({
    chat_id: {
        type: String,
        default: shortid.generate
    },
    room: {
        type: String,
        default: ''
    },
    chat: {
        type: Array,
        default: []
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});

const Chat = mongoose.model('Chat', chatSchema);
module.exports = Chat;