// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var currencySchema = new Schema({
    currency_id: {
        type: String,
        default:''
    },
    name: {
        type: String,
        default:''
    },
    symbol: {
        type: String,
        default:''
    },
    code: {
        type: String,
        default:''
    },
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
currencySchema.pre('save', function(callback) {
    idGenerator.generateId('currencies', 'currency_id', 'CUR', (err, ID) => {
        this.currency_id = ID;
        callback();
    });
});

var Currency = mongoose.model('Currency', currencySchema);
module.exports = Currency;