// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var measurementSchema = new Schema({
    measurement_id: String,
    title: Object,
    unit: String,
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
measurementSchema.pre('save', function(callback) {
    idGenerator.generateId('measurements', 'measurement_id', 'MES', (err, ID) => {
        this.measurement_id = ID;
        callback();
    });
});

var Measurement = mongoose.model('Measurement', measurementSchema);
module.exports = Measurement;