// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var moduleSchema = new Schema({
    module_id: String,
    title: String,
    path: {
        type: String,
        default:''
    },
    order_no: Number,
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
moduleSchema.pre('save', function(callback) {
    idGenerator.generateId('modules', 'module_id', 'MOD', (err, ID) => {
        this.module_id = ID;
        callback();
    });
});

var Modules = mongoose.model('Module', moduleSchema);
module.exports = Modules;