// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var paymentFreSchema = new Schema({
    payment_frequency_id: {
        type: String,
        default:''
    },
    title: {
        type: Object,
        default:{}
    },
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
paymentFreSchema.pre('save', function(callback) {
    idGenerator.generateId('payment_frequencies', 'payment_frequency_id', 'PYF', (err, ID) => {
        this.payment_frequency_id = ID;
        callback();
    });
});

var Payment_frequency = mongoose.model('Payment_frequency', paymentFreSchema);
module.exports = Payment_frequency;