// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var seekerFavSchema = new Schema({
    favourite_id: {
        type: String,
        default:''
    },
    property_id: {
        type: String,
        default:''
    },
    customer_id: {
        type: String,
        default:''
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
seekerFavSchema.pre('save', function(callback) {
    idGenerator.generateId('seeker_favourites', 'favourite_id', 'SEF', (err, ID) => {
        this.favourite_id = ID;
        callback();
    });
});

var Seeker_favourite = mongoose.model('Seeker_favourite', seekerFavSchema);
module.exports = Seeker_favourite;