// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var vehicleTypeSchema = new Schema({
    vehicle_type_id: {
        type: String,
        default:''
    },
    title: {
        type: Object,
        default:{}
    },
    description: {
        type: Object,
        default:{}
    },
    icon: {
        type: String,
        default:''
    },
    is_open_custom_box: {
        type: Boolean,
        default:false
    },
    code: {
        type: String,
        default:''
    },
    order_no: {
        type: Number,
        default:0
    },
    status: {
        type: String,
        enum: ['active', 'inactive']
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
vehicleTypeSchema.pre('save', function(callback) {
    idGenerator.generateId('vehicle_types', 'vehicle_type_id', 'VET', (err, ID) => {
        this.vehicle_type_id = ID;
        callback();
    });
});

var Vehicle_type = mongoose.model('Vehicle_type', vehicleTypeSchema);
module.exports = Vehicle_type;