// grab the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
const idGenerator = require('./../utils/id-generator');

// create a schema
var vehicleSchema = new Schema({
    vehicle_id: {
        type: String,
        default:''
    },
    customer_id: {
        type: String,
        default:''
    },
    vehicle_number: {
        type: String,
        default:''
    },
    vehicle_color_id: {
        type: String,
        default:''
    },
    vehicle_type_id: {
        type: String,
        default:''
    },
    photo: {
        type: String,
        default:''
    },
    is_default: {
        type: Boolean,
        enum: false
    },
    is_electric: {
        type: Boolean,
        enum: false
    },
    vehicle_make: {
        type: String,
        default:''
    },
    vehicle_model: {
        type: String,
        default:''
    },
    width: {
        type: Number,
        default:0
    },
    height: {
        type: Number,
        default:0
    },
    length: {
        type: Number,
        default:0
    },
    created_at: {
        type: Date,
        default: Date.now
    },
    updated_at: {
        type: Date,
        default: Date.now
    }
});


// // Execute before each user.save() call
vehicleSchema.pre('save', function(callback) {
    idGenerator.generateId('vehicles', 'vehicle_id', 'VEH', (err, ID) => {
        this.vehicle_id = ID;
        callback();
    });
});

var Vehicle = mongoose.model('Vehicle', vehicleSchema);
module.exports = Vehicle;