'use strict';

let _ = require('underscore');
const express = require('express');
const config = require('./../../config');
const responseCodes = require('./../../helpers/response-codes');
const logger = require('./../../utils/logger');
const jsonResponse = require('./../../utils/json-response');
const errors = require('./../../utils/dz-errors-api');
const router = express.Router();
const cronHandler = require('./../../model_handlers/api/cron-handler');

/*
    Name : Cron Run for payput
    Purpose : Cron Run for payput
    Original Author : Gaurav Patel
    Created At : 15th Nov 2021
*/
router.get('/payout', async(req, res) => {
    try {
        req.query.code = config.default_language
        let response = await cronHandler.payout(req.query);
        jsonResponse(res, responseCodes.OK, errors.noError(), response);
    } catch (error) {
        try {
            jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
            return;
        } catch (error) {
            jsonResponse(res, responseCodes.InternalServer, errors.internalServer(true, req.query.code), null);
            return;
        }
    }
});

module.exports = router;