'use strict';

const responseCodes =  require('./../../helpers/response-codes');
const logger = require('./../../utils/logger');
const jsonResponse = require('./../../utils/json-response');
const errors = require('./../../utils/dz-errors');
const express = require('express');
const router = express.Router();
const _ = require('underscore');
const bookingHandler = require('./../../model_handlers/backend/booking-handler');

router.get('/get',function (req, res) {
	bookingHandler.get(req,function (error, languages) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), languages);
	});
});

router.get('/details',function (req, res) {
	bookingHandler.details(req,function (error, languages) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), languages);
	});
});

router.get('/get-customers-spots',function (req, res) {
	bookingHandler.getCustomersSpots(req.query,function (error, languages) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), languages);
	});
});


module.exports = router;