'use strict';

const responseCodes =  require('./../../helpers/response-codes');
const logger = require('./../../utils/logger');
const jsonResponse = require('./../../utils/json-response');
const errors = require('./../../utils/dz-errors');
const express = require('express');
const router = express.Router();
const dashboardHandler = require('./../../model_handlers/backend/dashboard-handler');

router.get('/statistics', function (req, res) {
	dashboardHandler.statistics(req.query,function (error, labels) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), labels);
	});
});

router.get('/property-statistics', function (req, res) {
	dashboardHandler.propertyPtatistics(req.query,function (error, labels) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), labels);
	});
});

router.get('/sales', function (req, res) {
	dashboardHandler.sales(req,function (error, labels) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), labels);
	});
});

router.get('/earnings', function (req, res) {
	dashboardHandler.earnings(req,function (error, labels) {
		if (error) {
			jsonResponse(res, error.code, errors.formatErrorForWire(error), null);
			return;
		}
		jsonResponse(res, responseCodes.OK, errors.noError(), labels);
	});
});

module.exports = router;