/**
 * Calculate reservation charges with stripe gateway
 * @param {Number} amount 
 * @param {Number} commission 
 * @returns  gateway_charge , company_earnings ,owner_earnings 
 */
exports.reservationCharges = (amount = 0, commission = 0) => {
    commission = commission / 100
    let gateway_charge = Math.round(((amount * 0.029) + 0.30) * 100) / 100;
    let company_earning = Math.round(((amount - gateway_charge) * commission) * 100) / 100;
    let owner_earning = Math.round((amount - gateway_charge - company_earning) * 100) / 100;
    return {
        gateway_charge: gateway_charge || 0,
        company_earning: company_earning || 0,
        owner_earning: owner_earning || 0,
    }
}